import { api, renderless } from "@opentinyvue/vue-renderless/popeditor/vue";
import { defineComponent, props, directive, setup as _setup } from "@opentinyvue/vue-common";
import { IconChevronUp, IconChevronDown, IconClose } from "@opentinyvue/vue-icon";
import Input from "@opentinyvue/vue-input";
import DialogBox from "@opentinyvue/vue-dialog-box";
import Grid from "@opentinyvue/vue-grid";
import Pager from "@opentinyvue/vue-pager";
import Tree from "@opentinyvue/vue-tree";
import SelectedBox from "@opentinyvue/vue-selected-box";
import { Clickoutside } from "@opentinyvue/vue-directive";
var __vue2_script = defineComponent({
  components: {
    IconClose: IconClose(),
    IconChevronDown: IconChevronDown(),
    IconChevronUp: IconChevronUp(),
    TinyInput: Input,
    TinyGrid: Grid,
    TinyPager: Pager,
    TinyDialogBox: DialogBox,
    TinyTree: Tree,
    TinySelectedBox: SelectedBox
  },
  directives: directive({
    Clickoutside
  }),
  emits: ["update:modelValue", "change", "page-change", "popup", "size-change", "created"],
  props: [].concat(props, ["dataset", "placeholder", "autoLookup", "beforeReset", "textRenderSource", "resize", "size", "trigger", "conditions", "disabled", "gridOp", "alwaysLoad", "remoteSearch", "treeOp", "icon", "iconSearch", "initSelectedDatas", "multi", "pagerOp", "popseletor", "readonly", "showClearBtn", "showHistory", "showPager", "textField", "textSplit", "title", "modelValue", "valueField", "valueSplit", "width", "dialogClass", "tabindex", "draggable", "placement", "popperAppendToBody", "suggest", "beforeClose", "showSelectedBox", "selectedBoxOp", "tooltipConfig", "autoReset", "radioChangeClose"]),
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "tiny-popeditor"
  }, [_c("tiny-input", {
    ref: "reference",
    class: {
      "tiny-popeditor-readonly": _vm.state.readonly,
      suggest: _vm.suggest
    },
    attrs: {
      "size": _vm.size,
      "placeholder": _vm.placeholder,
      "disabled": _vm.state.disabled,
      "readonly": _vm.state.readonly,
      "tabindex": _vm.tabindex,
      "validate-event": !_vm.state.open
    },
    on: {
      "click": function click($event) {
        return _vm.handleOpen($event);
      },
      "update:modelValue": _vm.doSuggesst
    },
    nativeOn: {
      "mouseover": function mouseover($event) {
        _vm.state.inputHover = true;
      },
      "mouseleave": function mouseleave($event) {
        _vm.state.inputHover = false;
      }
    },
    scopedSlots: _vm._u([{
      key: "suffix",
      fn: function fn() {
        return [_c("span", [_vm.showClearBtn && _vm.state.commitValue && _vm.suggest && _vm.state.inputHover ? _c("icon-close", {
          staticClass: "tiny-svg-size tiny-svg__popeditor",
          staticStyle: {
            "margin-right": "8px"
          },
          on: {
            "click": function click($event) {
              $event.stopPropagation();
              return _vm.handleClear.apply(null, arguments);
            }
          }
        }) : _vm._e(), _vm.suggest && _vm.state.showSuggestPanel ? _c("icon-chevron-up", {
          staticClass: "tiny-svg-size tiny-svg__popeditor tiny-chevron",
          on: {
            "click": function click($event) {
              $event.stopPropagation();
              return _vm.closeSuggestPanel(true);
            }
          }
        }) : _vm._e(), _vm.suggest && !_vm.state.showSuggestPanel ? _c("icon-chevron-down", {
          staticClass: "tiny-svg-size tiny-svg__popeditor tiny-chevron",
          on: {
            "click": function click($event) {
              $event.stopPropagation();
              return _vm.doSuggesstNow.apply(null, arguments);
            }
          }
        }) : _vm._e(), _vm.showClearBtn && !!_vm.state.display && !_vm.suggest ? _c("icon-close", {
          staticClass: "tiny-svg-size tiny-svg__popeditor",
          on: {
            "click": function click($event) {
              $event.stopPropagation();
              return _vm.handleClear.apply(null, arguments);
            }
          }
        }) : _vm._e(), !(_vm.showClearBtn && !!_vm.state.display && !_vm.suggest) || !_vm.suggest && !_vm.readonly ? _c(_vm.icon, {
          tag: "component",
          staticClass: "tiny-svg-size tiny-svg__popeditor",
          on: {
            "click": function click($event) {
              $event.stopPropagation();
              return _vm.openDialog.apply(null, arguments);
            }
          }
        }) : _vm._e()], 1)];
      },
      proxy: true
    }]),
    model: {
      value: _vm.state.display,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "display", $$v);
      },
      expression: "state.display"
    }
  }), _c("transition", {
    attrs: {
      "name": "tiny-zoom-in-top"
    },
    on: {
      "after-leave": _vm.doDestroy
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.showSuggestPanel,
      expression: "state.showSuggestPanel"
    }],
    ref: "popper"
  }, [_vm.state.showSuggestPanel ? _c("tiny-grid", _vm._b({
    ref: "suggest",
    attrs: {
      "auto-resize": "",
      "loading": _vm.state.loading,
      "max-height": "300px",
      "highlight-current-row": true,
      "columns": _vm.state.baseColumns,
      "data": _vm.state.suggestList,
      "row-id": _vm.valueField,
      "select-config": {
        checkRowKeys: _vm.state.selectedValues
      },
      "radio-config": {
        checkRowKey: _vm.state.commitValue,
        trigger: _vm.trigger
      },
      "tooltip-config": _vm.tooltipConfig
    },
    on: {
      "select-all": _vm.sourceGridSelectAll,
      "select-change": _vm.sourceGridSelectChange,
      "radio-change": _vm.suggestRadioChange
    }
  }, "tiny-grid", _vm.gridOp, false)) : _vm._e()], 1)]), _c("tiny-dialog-box", {
    ref: "popeditorDialogBox",
    staticClass: "tiny-popeditor__dialog-box",
    attrs: {
      "visible": _vm.state.open,
      "resize": _vm.resize,
      "draggable": _vm.draggable,
      "append-to-body": "",
      "title": _vm.state.getTitle,
      "close-on-click-modal": false,
      "width": _vm.state.modalWidth,
      "before-close": _vm.handleBeforeClose,
      "dialog-class": _vm.dialogClass
    },
    on: {
      "update:visible": function updateVisible($event) {
        _vm.state.open = $event;
      },
      "close": function close($event) {
        return _vm.$parent.$emit("close");
      },
      "closed": function closed($event) {
        _vm.state.showContent = false;
      }
    },
    scopedSlots: _vm._u([{
      key: "footer",
      fn: function fn() {
        return [_vm.state.theme === "saas" ? _c("span", {
          staticClass: "tiny-toolbar"
        }, [_vm._t("footer", function() {
          return [_c("button", {
            staticClass: "tiny-button tiny-button--default",
            attrs: {
              "type": "button"
            },
            on: {
              "click": _vm.handleCancel
            }
          }, [_c("span", [_vm._v(_vm._s(_vm.t("ui.popeditor.cancel")))])]), _c("button", {
            staticClass: "tiny-button tiny-button--primary",
            attrs: {
              "type": "button"
            },
            on: {
              "click": _vm.handleConfirm
            }
          }, [_c("span", [_vm._v(_vm._s(_vm.t("ui.popeditor.confirm")))])])];
        }, {
          "confirm": _vm.handleConfirm,
          "cancel": _vm.handleCancel
        })], 2) : _c("span", {
          staticClass: "tiny-toolbar"
        }, [_vm._t("footer", function() {
          return [_c("button", {
            staticClass: "tiny-button tiny-button--primary",
            attrs: {
              "type": "button"
            },
            on: {
              "click": _vm.handleConfirm
            }
          }, [_c("span", [_vm._v(_vm._s(_vm.t("ui.popeditor.confirm")))])]), _c("button", {
            staticClass: "tiny-button tiny-button--default",
            attrs: {
              "type": "button"
            },
            on: {
              "click": _vm.handleCancel
            }
          }, [_c("span", [_vm._v(_vm._s(_vm.t("ui.popeditor.cancel")))])])];
        }, {
          "confirm": _vm.handleConfirm,
          "cancel": _vm.handleCancel
        })], 2)];
      },
      proxy: true
    }], null, true)
  }, [_vm.state.showContent ? [_vm.state.conditions.length && _vm.popseletor === "grid" ? _c("div", {
    staticClass: "tiny-popeditor-top"
  }, [_vm._t("search", function() {
    return [_c("ul", {
      staticClass: "tiny-popeditor__search-lists"
    }, _vm._l(_vm.conditions, function(item) {
      return _c("li", {
        key: item.field,
        staticClass: "tiny-popeditor__search-item",
        style: {
          width: 100 * ((item.span || 6) / 12) + "%"
        }
      }, [_c("label", {
        staticClass: "tiny-popeditor__search-label",
        style: {
          width: item.labelWidth
        },
        attrs: {
          "title": item.label
        }
      }, [_vm._v(" " + _vm._s(item.label) + " ")]), _c(item.component || "tiny-input", _vm._b({
        tag: "component",
        staticClass: "tiny-popeditor__search-input",
        attrs: {
          "novalid": true
        },
        on: {
          "keydown": function keydown($event) {
            if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter")) return null;
            return _vm.handleSearch.apply(null, arguments);
          }
        },
        model: {
          value: _vm.state.search[item.field],
          callback: function callback($$v) {
            _vm.$set(_vm.state.search, item.field, $$v);
          },
          expression: "state.search[item.field]"
        }
      }, "component", item.attrs, false))], 1);
    }), 0), _vm.state.theme === "saas" ? _c("div", {
      staticClass: "tiny-popeditor__search-footer"
    }, [_c("button", {
      staticClass: "tiny-button tiny-button--default",
      attrs: {
        "type": "button"
      },
      on: {
        "click": _vm.handleReset
      }
    }, [_c("span", [_vm._v(_vm._s(_vm.t("ui.popeditor.reset")))])]), _c("button", {
      staticClass: "tiny-button tiny-button--primary",
      attrs: {
        "type": "button"
      },
      on: {
        "click": _vm.handleSearch
      }
    }, [_c("span", [_vm._v(_vm._s(_vm.t("ui.popeditor.search")))])])]) : _c("div", {
      staticClass: "tiny-popeditor__search-footer"
    }, [_c("button", {
      staticClass: "tiny-button tiny-button--primary",
      attrs: {
        "type": "button"
      },
      on: {
        "click": _vm.handleSearch
      }
    }, [_c("span", [_vm._v(_vm._s(_vm.t("ui.popeditor.search")))])]), _c("button", {
      staticClass: "tiny-button tiny-button--default",
      attrs: {
        "type": "button"
      },
      on: {
        "click": _vm.handleReset
      }
    }, [_c("span", [_vm._v(_vm._s(_vm.t("ui.popeditor.reset")))])])])];
  }, {
    "searchOp": _vm.state.searchOp
  })], 2) : _vm._e(), _vm.popseletor === "grid" ? _c("div", {
    staticClass: "tiny-popeditor-body"
  }, [_c("div", {
    class: ["tiny-popeditor-body__left", {
      "tiny-popeditor-body__radio": !_vm.multi
    }]
  }, [_c("div", {
    staticClass: "tiny-popeditor__tabs"
  }, [_c("div", {
    staticClass: "tiny-popeditor__tabs-head"
  }, [_c("ul", [_vm.showHistory ? _c("li", {
    class: {
      "tiny-popeditor__tabs-selected": _vm.state.activeName === "history"
    },
    on: {
      "click": function click($event) {
        _vm.state.activeName = "history";
      }
    }
  }, [_vm._t("title-history", function() {
    return [_c("span", [_vm._v(_vm._s(_vm.t("ui.popeditor.historyLists")))])];
  })], 2) : _vm._e(), _c("li", {
    class: {
      "tiny-popeditor__tabs-selected": _vm.state.activeName === "source"
    },
    on: {
      "click": function click($event) {
        _vm.state.activeName = "source";
      }
    }
  }, [_vm._t("title-source", function() {
    return [_c("span", [_vm._v(_vm._s(_vm.t("ui.popeditor.sourceLists")))])];
  })], 2)])]), _c("div", {
    staticClass: "tiny-popeditor__tabs-body"
  }, [_vm.state.activeName === "history" ? _c("div", {
    staticClass: "tabs-body-item"
  }, [_c("tiny-grid", _vm._b({
    ref: "historyGrid",
    attrs: {
      "height": "290px",
      "size": "mini",
      "highlight-current-row": true,
      "columns": _vm.state.baseColumns,
      "data": _vm.state.historyGridDataset,
      "row-id": _vm.valueField,
      "select-config": {
        checkRowKeys: _vm.state.selectedValues
      },
      "tooltip-config": _vm.tooltipConfig
    },
    on: {
      "select-all": _vm.sourceGridSelectAll,
      "select-change": _vm.sourceGridSelectChange
    }
  }, "tiny-grid", _vm.gridOp, false))], 1) : _vm._e(), _vm.state.activeName === "source" ? _c("div", {
    staticClass: "tabs-body-item"
  }, [_vm.multi ? _c("tiny-grid", _vm._b({
    ref: "sourceGrid",
    attrs: {
      "auto-resize": "",
      "loading": _vm.state.loading,
      "height": "290px",
      "size": "mini",
      "highlight-current-row": true,
      "columns": _vm.state.baseColumns,
      "data": _vm.state.sourceGridDataset,
      "row-id": _vm.valueField,
      "select-config": {
        checkRowKeys: _vm.state.selectedValues
      },
      "tooltip-config": _vm.tooltipConfig
    },
    on: {
      "select-all": _vm.sourceGridSelectAll,
      "select-change": _vm.sourceGridSelectChange
    }
  }, "tiny-grid", _vm.gridOp, false)) : _c("tiny-grid", _vm._b({
    ref: "sourceGrid",
    attrs: {
      "auto-resize": "",
      "loading": _vm.state.loading,
      "height": "290px",
      "size": "mini",
      "highlight-current-row": true,
      "columns": _vm.state.baseColumns,
      "data": _vm.state.sourceGridDataset,
      "row-id": _vm.valueField,
      "radio-config": {
        checkRowKey: _vm.state.commitValue,
        trigger: _vm.trigger
      },
      "tooltip-config": _vm.tooltipConfig
    },
    on: {
      "radio-change": _vm.radioChangeFn
    }
  }, "tiny-grid", _vm.gridOp, false)), _vm.showPager ? _c("tiny-pager", _vm._b({
    on: {
      "current-change": _vm.handleSizeChange,
      "size-change": _vm.handleNumberPageChange
    }
  }, "tiny-pager", _vm.state.pagerConfig, false)) : _vm._e()], 1) : _vm._e()])])]), _vm.multi ? _c("div", {
    staticClass: "tiny-popeditor-body__right"
  }, [_c("div", {
    staticClass: "tiny-popeditor__tabs"
  }, [_c("div", {
    staticClass: "tiny-popeditor__tabs-head"
  }, [_c("ul", [_c("li", {
    staticClass: "tiny-popeditor__tabs-selected"
  }, [_vm._t("title-selection", function() {
    return [_c("span", [_vm._v(_vm._s(_vm.t("ui.popeditor.selectionLists")))])];
  })], 2)])]), _c("div", {
    staticClass: "tiny-popeditor__tabs-body"
  }, [_c("div", {
    staticClass: "tabs-body-item"
  }, [_vm.showSelectedBox ? _c("tiny-selected-box", _vm._b({
    ref: "selectedBox",
    staticStyle: {
      "height": "290px"
    },
    attrs: {
      "select": _vm.state.selectedDatas
    },
    on: {
      "clear": _vm.selectedBoxClear,
      "delete": _vm.selectedBoxDelete,
      "drag": _vm.selectedBoxDrag
    },
    scopedSlots: _vm._u([_vm.slots.select ? {
      key: "select",
      fn: function fn(params) {
        return [_vm._t("select", null, null, params)];
      }
    } : null, _vm.slots.button ? {
      key: "button",
      fn: function fn(params) {
        return [_vm._t("button", null, null, params)];
      }
    } : null, _vm.slots.clear ? {
      key: "clear",
      fn: function fn(params) {
        return [_vm._t("clear", null, null, params)];
      }
    } : null, _vm.slots.option ? {
      key: "option",
      fn: function fn(params) {
        return [_vm._t("option", null, null, params)];
      }
    } : null, _vm.slots.close ? {
      key: "close",
      fn: function fn(params) {
        return [_vm._t("close", null, null, params)];
      }
    } : null], null, true)
  }, "tiny-selected-box", _vm.selectedBoxOp, false)) : _c("tiny-grid", _vm._b({
    ref: "selectedGrid",
    attrs: {
      "auto-resize": "",
      "columns": _vm.state.baseColumns,
      "data": _vm.state.selectedDatas,
      "height": "290px",
      "size": "mini",
      "row-id": _vm.valueField,
      "select-config": {
        checkRowKeys: _vm.state.selectedValues
      },
      "tooltip-config": _vm.tooltipConfig
    },
    on: {
      "select-all": _vm.selectedGridSelectAll,
      "select-change": _vm.selectedGridSelectChange
    }
  }, "tiny-grid", _vm.gridOp, false)), _vm.showPager ? _c("div", {
    staticStyle: {
      "height": "50px"
    }
  }) : _vm._e()], 1)])])]) : _vm._e()]) : _vm._e(), _vm.popseletor === "tree" ? _c("div", {
    staticClass: "tiny-popeditor__tree"
  }, [_c("tiny-input", {
    staticClass: "tiny-popeditor__filter-input",
    attrs: {
      "placeholder": _vm.t("ui.popeditor.filterNode"),
      "prefix-icon": _vm.iconSearch,
      "suffix-icon": _vm.iconSearch
    },
    model: {
      value: _vm.state.filterText,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "filterText", $$v);
      },
      expression: "state.filterText"
    }
  }), _c("div", {
    staticClass: "tiny-popeditor__tree-wrapper",
    style: {
      maxHeight: _vm.state.treeWrapperMaxHeight
    }
  }, [_c("tiny-tree", _vm._b({
    ref: "tree",
    on: {
      "check-change": _vm.treeCheckChange
    }
  }, "tiny-tree", _vm.state.treeOp, false))], 1)], 1) : _vm._e()] : _vm._e()], 2)], 1);
};
var staticRenderFns = [];
function normalizeComponent(scriptExports, render3, staticRenderFns2, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render3) {
    options.render = render3;
    options.staticRenderFns = staticRenderFns2;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();
export {
  pc as default
};
